#!/bin/sh
TARGET=$1
DIFFS="sys-pfaltq-freebsd-0.1alpha.diff"
SRCS="altq net netinet"

if [ ! $TARGET ]; then
	echo "No TARGET given! Useing /usr/src/sys"
	TARGET=/usr/src/sys
	echo -n "---backup:"
	if ! (cp -r /usr/src/sys /usr/src/sys.orig && echo "ok"); then
		echo "failed"
		exit 1
	fi
fi

echo "---patch:"
for diff in $DIFFS; do
	echo -n "   $dir ... "
	cat $diff | patch -F0 -p0 -d $TARGET 2>&1 | \
	    grep "fail\|fuzz\|offset" || echo "ok"
done

echo -n "---additional:"
for dir in $SRCS; do
	if [ ! -e $TARGET/$dir ]; then
		mkdir $TARGET/$dir
	fi
	for file in `ls -d $dir/*`; do
		if [ ! -d $file ]; then
			cp $file $TARGET/$dir/
		fi
	done
done
echo "ok"

echo -n "---clean:"
for file in `find $TARGET/* -name *.orig`; do
	rm $file
done
echo "ok"

echo "---done"
